#! /bin/sh
# This restore script is for Pupsave files made by Pupsave-backup.
# I started with selection buttons that I left for file and directory.
# But they proved to be a real pain and it was easier just to copy and
# rename the backed up Pupsave file manually.
# I am releasing this under GPL 2 and you can use or modify it as you wish
# By 8-bit (John C. Meyer) on 09/30/2011

progress() {
	FS="$PUPSAVE_FILE"
    LAST=${FS##*/} # Removes Path from filename
    chk=$(echo ${LAST/BKP})
    if [ ! "$chk" = "$LAST" ]; then
    newname=`echo $LAST | sed "s/...................$//"` #That is 19 dots in sed Removes date-time
    else newname="$LAST"
    fi
if [ "$FS" = "" ];then xmessage -name 'Pupsave Restore' -center -bg red -fg black "You must supply a Pupsave backup file.";exit 1;fi
if [ "$RST_PATH" = "" ];then xmessage -name 'Pupsave Restore' -center -bg red -fg black "You must supply a destination frugal directory";exit 1;fi
FD="$RST_PATH/$newname"
    echo FS = $FS
    echo newname = $newname
    echo with path = $RST_PATH/$newname
    echo FD = $FD


org_size=$(stat -c %s $FS)
dest_size=0
cp -f $FS $FD &
    sleep 0.3 

while [ $org_size -gt $dest_size ] ; do
   dest_size=$(stat -c %s $FD)
   pct=$((( 100 * $dest_size ) / $org_size ))
   echo $pct
    sleep 0.3 
  done; 
  echo ready
  xmessage -name 'Pupsave Restore' -center -bg green -fg black "        Restore Completed.         "
}; export -f progress

export BAR_DIALOG='
<variable>BAR_DIALOG</variable>
<vbox>
  <frame Progress>
    <text>
      <label>Now copying your file Please Wait.</label>
    </text>
    <progressbar>
      <variable>PROGRESS_BAR</variable>
      <label>Copy Progress</label>
      <input>progress</input>
      <action type="refresh">ENTRY</action>
      <action type="closewindow">BAR_DIALOG</action>
    </progressbar>
  </frame>
  <hbox>
    <button cancel>
      <action type="closewindow">BAR_DIALOG</action>
    </button>
  </hbox>
</vbox>
'


export PUPSAVE_RESTORE='
<window title="Restore for Frugal Pups" icon-name="gtk-convert" default_width="400">
 <vbox>
       <frame>
         <text editable="false" use-markup="true" xalign="0.001">
            <label>"<span color='"'green'"'>Pupsave backup to restore</span>"</label>
         </text>
         <hbox>
            <entry editable="true">
               <variable>PUPSAVE_FILE</variable>
               <input>"\$PUPSAVE_FILE"</input>
            </entry>
            <button>
               <input file stock="gtk-file"></input>
               <action type="fileselect">PUPSAVE_FILE</action>
            </button>
         </hbox>
         <text editable="false" use-markup="true" xalign="0.001">
            <label>"<span color='"'blue'"'>Frugal Puppy directory for restore</span>"</label>
         </text>
         <hbox>
            <entry editable="true" accept="directory">
               <variable>RST_PATH</variable>
               <input>"\$RST_PATH"</input>
            </entry>
            <button>
               <input file stock="gtk-open"></input>
               <action type="fileselect">RST_PATH</action>
            </button>
         </hbox>
            <frame>
         <vbox>
          <text><label>Use this utility to restore a backed up pupsave file made with Pupsave-backup from hotbkp to a frugal Puppy.  Both source and destination directories must be mounted.  Drag and Drop pupsave backup file and frugal puppy directory to entry boxes using ROX.</label></text>
         </vbox>
         </frame> 
      </frame>
<hbox>
<button><label>Restore</label>
      <action type="launch">BAR_DIALOG</action>
      
</button>
<button cancel></button>
</hbox>
</vbox>
</window>
'
gtkdialog4 -p PUPSAVE_RESTORE --geometry 550x300 +0+0
unset BAR_DIALOG
unset MAIN_DIALOG
